package na_zywo;

import java.util.concurrent.atomic.AtomicInteger;

public class Mutowalnosc1 {

    static void test1(int x) {
        System.out.println("test1 x = " + x);
        x += 1;
        System.out.println("test1 x = " + x);
    }

    static void test2(Integer y) {
        System.out.println("test2 y = " + y);
        y += 1;
        // y = y+1 , a tak naprawdę y = new Integer(y.intValue()+1);
        // y wskazuje na nowy obiekt; w praktyce: zmiana y jest lokalna, a main jej nie widzi
        System.out.println("test2 y = " + y);
    }

    static void test3(AtomicInteger z) {
        System.out.println("test3 z = " + z);
        z.incrementAndGet();
        System.out.println("test3 z = " + z);
    }

    static void test4(String s) {
        System.out.println(s);
        s += " ma kota";
        System.out.println(s);
    }

    static void test5(StringBuilder s) {
        System.out.println(s);
        s.append(" ma psa");
        System.out.println(s);
    }

    public static void main(String[] args) {
        int x = 100;
        test1(x);
        System.out.println("za test1: " + x);
        System.out.println();

        Integer y = 200;
        test2(y);
        System.out.println("za test2: " + y);
        System.out.println();

        AtomicInteger z = new AtomicInteger(300);
        test3(z);
        System.out.println("za test3: " + z);
        System.out.println();

        String napis = "Ala";
        System.out.println(napis);
        test4(napis);
        System.out.println(napis);
        System.out.println();

        StringBuilder builder = new StringBuilder("Ola");
        System.out.println(builder);
        test5(builder);
        System.out.println(builder);
    }
}

// Znane klasy niemutowalne:
// String, Integer, Long, Double itd., BigInteger i BigDecimal
// LocalDate, LocalTime itd
